# Overview
`templates.txt` contains the templates we used for the E2E dataset. 
These templates follow similar logic to the TUDA system, except that the connection phrases and unnecessary template ordering logics are omitted.
 
# Template Format
- The lines starting with # denote the name of a template unit.
	- Note that we use #WholeTemplate to output the sequence of template unit instantiations for text stitching. It decides the orders of smaller template units.
- Each line denote a template unit candidate expression. It is constructed by several consecutive template units.
	- Template unit follows the format of [TEMP:xxx]. Each template unit is separated by |.
	- Slot follows the format of [SLOT:xxx]
	- Conditions and expression contents are separated by ???
    - Expressions with conditions have a higher priority over expressions without conditions
    - NULL refers to that, if no conditions are met, this template unit can produce empty string. Otherwise, if there is no NULL indicator, the template system returns an error. 
- A template unit can contain:
	- String
	- Slot
	- Other template units.

Note that there is an implicit condition that, if certain slots in an expression are missing, we consider the condition of this expression is not met. 


